/***************************** LICENSE START ***********************************

 Copyright 2014 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

#ifndef MethodCommand_H
#define MethodCommand_H

#include "Command.h"

class MethodCommand : public Command
{
public:
    typedef void (IconObject::*Proc)();

    MethodCommand(const string&, Proc);
    virtual ~MethodCommand();

    virtual void execute(IconObject*);
    static void execute(const string&, IconObject*);

protected:
    string name_;

private:
    // No copy allowed
    MethodCommand(const MethodCommand&);
    MethodCommand& operator=(const MethodCommand&);

    Proc proc_;
};

#endif
